/*-*- mode:unix-assembly; indent-tabs-mode:t; tab-width:8; coding:utf-8     -*-│
│vi: set et ft=asm ts=8 tw=8 fenc=utf-8                                     :vi│
╞══════════════════════════════════════════════════════════════════════════════╡
│ Copyright 2020 Justine Alexandra Roberts Tunney                              │
│                                                                              │
│ Permission to use, copy, modify, and/or distribute this software for         │
│ any purpose with or without fee is hereby granted, provided that the         │
│ above copyright notice and this permission notice appear in all copies.      │
│                                                                              │
│ THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL                │
│ WARRANTIES WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED                │
│ WARRANTIES OF MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE             │
│ AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL         │
│ DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR        │
│ PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER               │
│ TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR             │
│ PERFORMANCE OF THIS SOFTWARE.                                                │
╚─────────────────────────────────────────────────────────────────────────────*/
#include "libc/macros.internal.h"

	.rodata
	.align	64			# for cacheline yoinking
kAesSboxInverse:
	.byte	0x52,0x09,0x6a,0xd5,0x30,0x36,0xa5,0x38
	.byte	0xbf,0x40,0xa3,0x9e,0x81,0xf3,0xd7,0xfb
	.byte	0x7c,0xe3,0x39,0x82,0x9b,0x2f,0xff,0x87
	.byte	0x34,0x8e,0x43,0x44,0xc4,0xde,0xe9,0xcb
	.byte	0x54,0x7b,0x94,0x32,0xa6,0xc2,0x23,0x3d
	.byte	0xee,0x4c,0x95,0x0b,0x42,0xfa,0xc3,0x4e
	.byte	0x08,0x2e,0xa1,0x66,0x28,0xd9,0x24,0xb2
	.byte	0x76,0x5b,0xa2,0x49,0x6d,0x8b,0xd1,0x25
	.byte	0x72,0xf8,0xf6,0x64,0x86,0x68,0x98,0x16
	.byte	0xd4,0xa4,0x5c,0xcc,0x5d,0x65,0xb6,0x92
	.byte	0x6c,0x70,0x48,0x50,0xfd,0xed,0xb9,0xda
	.byte	0x5e,0x15,0x46,0x57,0xa7,0x8d,0x9d,0x84
	.byte	0x90,0xd8,0xab,0x00,0x8c,0xbc,0xd3,0x0a
	.byte	0xf7,0xe4,0x58,0x05,0xb8,0xb3,0x45,0x06
	.byte	0xd0,0x2c,0x1e,0x8f,0xca,0x3f,0x0f,0x02
	.byte	0xc1,0xaf,0xbd,0x03,0x01,0x13,0x8a,0x6b
	.byte	0x3a,0x91,0x11,0x41,0x4f,0x67,0xdc,0xea
	.byte	0x97,0xf2,0xcf,0xce,0xf0,0xb4,0xe6,0x73
	.byte	0x96,0xac,0x74,0x22,0xe7,0xad,0x35,0x85
	.byte	0xe2,0xf9,0x37,0xe8,0x1c,0x75,0xdf,0x6e
	.byte	0x47,0xf1,0x1a,0x71,0x1d,0x29,0xc5,0x89
	.byte	0x6f,0xb7,0x62,0x0e,0xaa,0x18,0xbe,0x1b
	.byte	0xfc,0x56,0x3e,0x4b,0xc6,0xd2,0x79,0x20
	.byte	0x9a,0xdb,0xc0,0xfe,0x78,0xcd,0x5a,0xf4
	.byte	0x1f,0xdd,0xa8,0x33,0x88,0x07,0xc7,0x31
	.byte	0xb1,0x12,0x10,0x59,0x27,0x80,0xec,0x5f
	.byte	0x60,0x51,0x7f,0xa9,0x19,0xb5,0x4a,0x0d
	.byte	0x2d,0xe5,0x7a,0x9f,0x93,0xc9,0x9c,0xef
	.byte	0xa0,0xe0,0x3b,0x4d,0xae,0x2a,0xf5,0xb0
	.byte	0xc8,0xeb,0xbb,0x3c,0x83,0x53,0x99,0x61
	.byte	0x17,0x2b,0x04,0x7e,0xba,0x77,0xd6,0x26
	.byte	0xe1,0x69,0x14,0x63,0x55,0x21,0x0c,0x7d
	.endfn	kAesSboxInverse,globl,hidden
	.previous
