#ifndef COSMOPOLITAN_LIBC_SYSV_CONSTS_PTRACE_H_
#define COSMOPOLITAN_LIBC_SYSV_CONSTS_PTRACE_H_
#include "libc/runtime/symbolic.h"
#if !(__ASSEMBLER__ + __LINKER__ + 0)
COSMOPOLITAN_C_START_

extern const long PTRACE_TRACEME;
extern const long PTRACE_PEEKTEXT;
extern const long PTRACE_PEEKDATA;
extern const long PTRACE_PEEKUSER;
extern const long PTRACE_POKETEXT;
extern const long PTRACE_POKEDATA;
extern const long PTRACE_POKEUSER;
extern const long PTRACE_CONT;
extern const long PTRACE_KILL;
extern const long PTRACE_SINGLESTEP;
extern const long PTRACE_GETREGS;
extern const long PTRACE_SETREGS;
extern const long PTRACE_GETFPREGS;
extern const long PTRACE_SETFPREGS;
extern const long PTRACE_ATTACH;
extern const long PTRACE_DETACH;
extern const long PTRACE_GETFPXREGS;
extern const long PTRACE_SETFPXREGS;
extern const long PTRACE_SYSCALL;
extern const long PTRACE_GETEVENTMSG;
extern const long PTRACE_GETSIGINFO;
extern const long PTRACE_SETOPTIONS;
extern const long PTRACE_SETSIGINFO;
extern const long PTRACE_GETREGSET;
extern const long PTRACE_GETSIGMASK;
extern const long PTRACE_INTERRUPT;
extern const long PTRACE_LISTEN;
extern const long PTRACE_PEEKSIGINFO;
extern const long PTRACE_SECCOMP_GET_FILTER;
extern const long PTRACE_SEIZE;
extern const long PTRACE_SETREGSET;
extern const long PTRACE_SETSIGMASK;
extern const long PTRACE_O_TRACESYSGOOD;
extern const long PTRACE_O_TRACEFORK;
extern const long PTRACE_O_TRACEVFORK;
extern const long PTRACE_O_TRACECLONE;
extern const long PTRACE_O_TRACEEXEC;
extern const long PTRACE_O_TRACEVFORKDONE;
extern const long PTRACE_O_TRACEEXIT;
extern const long PTRACE_O_MASK;
extern const long PTRACE_EVENT_FORK;
extern const long PTRACE_EVENT_VFORK;
extern const long PTRACE_EVENT_CLONE;
extern const long PTRACE_EVENT_EXEC;
extern const long PTRACE_EVENT_VFORK_DONE;
extern const long PTRACE_EVENT_EXIT;

COSMOPOLITAN_C_END_
#endif /* !(__ASSEMBLER__ + __LINKER__ + 0) */

#define PTRACE_TRACEME            SYMBOLIC(PTRACE_TRACEME)
#define PTRACE_PEEKTEXT           SYMBOLIC(PTRACE_PEEKTEXT)
#define PTRACE_PEEKDATA           SYMBOLIC(PTRACE_PEEKDATA)
#define PTRACE_PEEKUSER           SYMBOLIC(PTRACE_PEEKUSER)
#define PTRACE_POKETEXT           SYMBOLIC(PTRACE_POKETEXT)
#define PTRACE_POKEDATA           SYMBOLIC(PTRACE_POKEDATA)
#define PTRACE_POKEUSER           SYMBOLIC(PTRACE_POKEUSER)
#define PTRACE_CONT               SYMBOLIC(PTRACE_CONT)
#define PTRACE_KILL               SYMBOLIC(PTRACE_KILL)
#define PTRACE_SINGLESTEP         SYMBOLIC(PTRACE_SINGLESTEP)
#define PTRACE_GETREGS            SYMBOLIC(PTRACE_GETREGS)
#define PTRACE_SETREGS            SYMBOLIC(PTRACE_SETREGS)
#define PTRACE_GETFPREGS          SYMBOLIC(PTRACE_GETFPREGS)
#define PTRACE_SETFPREGS          SYMBOLIC(PTRACE_SETFPREGS)
#define PTRACE_ATTACH             SYMBOLIC(PTRACE_ATTACH)
#define PTRACE_DETACH             SYMBOLIC(PTRACE_DETACH)
#define PTRACE_GETFPXREGS         SYMBOLIC(PTRACE_GETFPXREGS)
#define PTRACE_SETFPXREGS         SYMBOLIC(PTRACE_SETFPXREGS)
#define PTRACE_SYSCALL            SYMBOLIC(PTRACE_SYSCALL)
#define PTRACE_GETEVENTMSG        SYMBOLIC(PTRACE_GETEVENTMSG)
#define PTRACE_GETSIGINFO         SYMBOLIC(PTRACE_GETSIGINFO)
#define PTRACE_SETOPTIONS         SYMBOLIC(PTRACE_SETOPTIONS)
#define PTRACE_SETSIGINFO         SYMBOLIC(PTRACE_SETSIGINFO)
#define PTRACE_GETREGSET          SYMBOLIC(PTRACE_GETREGSET)
#define PTRACE_GETSIGMASK         SYMBOLIC(PTRACE_GETSIGMASK)
#define PTRACE_INTERRUPT          SYMBOLIC(PTRACE_INTERRUPT)
#define PTRACE_LISTEN             SYMBOLIC(PTRACE_LISTEN)
#define PTRACE_PEEKSIGINFO        SYMBOLIC(PTRACE_PEEKSIGINFO)
#define PTRACE_SECCOMP_GET_FILTER SYMBOLIC(PTRACE_SECCOMP_GET_FILTER)
#define PTRACE_SEIZE              SYMBOLIC(PTRACE_SEIZE)
#define PTRACE_SETREGSET          SYMBOLIC(PTRACE_SETREGSET)
#define PTRACE_SETSIGMASK         SYMBOLIC(PTRACE_SETSIGMASK)
#define PTRACE_O_TRACESYSGOOD     SYMBOLIC(PTRACE_O_TRACESYSGOOD)
#define PTRACE_O_TRACEFORK        SYMBOLIC(PTRACE_O_TRACEFORK)
#define PTRACE_O_TRACEVFORK       SYMBOLIC(PTRACE_O_TRACEVFORK)
#define PTRACE_O_TRACECLONE       SYMBOLIC(PTRACE_O_TRACECLONE)
#define PTRACE_O_TRACEEXEC        SYMBOLIC(PTRACE_O_TRACEEXEC)
#define PTRACE_O_TRACEVFORKDONE   SYMBOLIC(PTRACE_O_TRACEVFORKDONE)
#define PTRACE_O_TRACEEXIT        SYMBOLIC(PTRACE_O_TRACEEXIT)
#define PTRACE_O_MASK             SYMBOLIC(PTRACE_O_MASK)
#define PTRACE_EVENT_FORK         SYMBOLIC(PTRACE_EVENT_FORK)
#define PTRACE_EVENT_VFORK        SYMBOLIC(PTRACE_EVENT_VFORK)
#define PTRACE_EVENT_CLONE        SYMBOLIC(PTRACE_EVENT_CLONE)
#define PTRACE_EVENT_EXEC         SYMBOLIC(PTRACE_EVENT_EXEC)
#define PTRACE_EVENT_VFORK_DONE   SYMBOLIC(PTRACE_EVENT_VFORK_DONE)
#define PTRACE_EVENT_EXIT         SYMBOLIC(PTRACE_EVENT_EXIT)

#endif /* COSMOPOLITAN_LIBC_SYSV_CONSTS_PTRACE_H_ */
